unit read_unit;

interface

uses windows;

procedure clearReadbuffer;
procedure startreading(filename : string);
procedure stopreading;
function getReadResult : boolean;
function readbyte : byte;
function readString : string;
function readWord : word;
function readDword : dword;
function readSmallInt : smallInt;
function readLongInt : longInt;
function readsingle : single;
function readdouble : double;

implementation

Var Rbuffer : array[0..99] of dword;
    bix     : word;
    accu    : dword;
    Acount  : byte;
    F       : file; //untyped
    Xferred : longInt;
    XFOK    : boolean;

procedure clearReadbuffer;
var i : word;
begin
 for i := 0 to 99 do Rbuffer[i] := 0;
 bix := 0;
 acount := 0;
 XFOK := true;
 xferred := 0;
end;

procedure startreading(filename : string);
begin
 clearReadBuffer;

//turn I/O checking off

{$I-}

 assignfile(F,filename);
 reset(f,4);              //init file, 4 byte record size = dword
 if IOresult <> 0 then    //ioresult = 0 if no errors
  begin
   closefile(f);
   XFOK := false;
  end; // I/O result
end;

procedure stopreading;
begin
 closefile(F);
end;

function  getReadResult : boolean;
begin
 result := XFOK;
end;

procedure readbuffer;
begin
 if XFOK then
  begin
   blockread(F,Rbuffer,100,xferred);
   if (IOresult <> 0) or (Xferred = 0) then
    begin
     XFOK := false;
     Xferred := 0;
   end;
  end;
 BIX := 0;
end;

procedure loadAccu;
begin
 accu := 0;
 if XFOK then
  begin
   if BIX >= xferred then readBuffer;
   accu := Rbuffer[BIX];
   inc(BIX);
   acount := 4;    //4 bytes loaded
   end;
end;

function readByte : byte;
begin
 if acount = 0 then loadaccu;
 result := accu and $ff;
 accu := accu shr 8;
 dec(acount);
end;

function readword : word;
begin
 if acount < 2 then loadAccu;
 result := accu and $ffff;
 accu := accu shr 16;
 dec(acount,2);
end;

function readstring : string;
var b : byte;
begin
 result := '';
 acount := 0;//start at dword bounderies
 repeat
  b := readbyte;
  if b <> 0 then result := result + chr(b);
 until b = 0;
 acount := 0;//skip remaining byte in accu
end;

function readDword : dword;
begin
 if acount < 4 then loadAccu;
 result := accu;
 acount := 0;
end;

function readSmallInt : smallInt;
//read smallInt
begin
 if acount < 2 then loadaccu;
 result := smallInt(accu and $ffff);
 accu := accu shr 16;
 dec(acount,2);
end;

function readLongInt : longInt;
var dw : dword;
begin
 dw := readDword;
 result :=longInt(dw);
end;

function readsingle  : single;
type Psingle = ^single;
var dw : dword;
begin
 dw := readDword;
 result := Psingle(@dw)^;
end;

function readdouble : double;
type Pdouble = ^double;
var adw : array[0..1] of dword;
begin
 adw[0] := readdword;
 adw[1] := readdword;
 result := Pdouble(@adw)^;
end;

end.
