unit write_unit;

interface

uses windows;

procedure clearwritebuffer;
procedure startwriting(filename : string);
procedure stopwriting;
function  getWriteResult : boolean;
procedure writebyte(b : byte);
procedure writeString(s : string);
procedure writeWord(w : word);
procedure writeDword(dw : dword);
procedure writeSmallInt(w : smallInt);
procedure writeLongInt(w : longInt);
procedure writesingle(ss : single);
procedure writedouble(dd : double);

implementation

Var wbuffer : array[0..99] of dword;
    bix     : word;
    accu    : dword;
    Acount  : byte;
    F       : file; //untyped
    Xferred : longInt;
    XFOK    : boolean;

procedure writeAccu;forward;
procedure writeBuffer(n : word);forward;

procedure startwriting(filename : string);
begin
 clearwriteBuffer;

//turn I/O checking off

{$I-}

 assignfile(F,filename);
 rewrite(f,4);            //init file, 4 byte record size = dword
 if IOresult <> 0 then    //ioresult = 0 if no errors
  begin
   closefile(f);
   XFOK := false;
  end; // I/O result

//turn I/O checking on

{$I+}

end;

procedure stopwriting;
begin
 if acount > 0 then writeaccu;
 if bix > 0 then writebuffer(bix);
 closefile(F);
end;

procedure clearwritebuffer;
var i : word;
begin
 for i := 0 to 99 do wbuffer[i] := 0;
 bix := 0;
 acount := 0;
 XFOK := true;
end;

function getWriteResult : boolean;
begin
 result := XFOK;
end; 

procedure writeBuffer(n : word);//write n dwords to disc
begin
 if XFOK then
  try
   blockwrite(f,wbuffer,n,xferred);//xferred is dwords written
  except
   XfOK := false;
  end;
  clearwritebuffer; //also reset bix,acount ,XFOK
end;

procedure writeAccu;
//accu --> buffer
begin
 if Acount > 0 then
  begin
   wbuffer[Bix] := accu;
   Acount := 0;
   inc(Bix);
   if Bix = 100 then writeBuffer(100);
   accu := 0;
   XFOK := true;
  end;
end;

procedure writebyte(b : byte);
//write byte to accu
var scnt : byte;//shift count
begin
 scnt := Acount shl 3;//multiply by 8
 accu := accu or (b shl scnt);
 inc(Acount);
 if Acount = 4 then writeAccu;
end;

procedure writeString(s : string);
var i : byte;
begin
 writeAccu;   //start at dword boundaries
 for i := 1 to length(s) do writebyte(byte(s[i]));
 writebyte(0);//end of string
 writeAccu;
end;

procedure writeWord(w : word);
var scnt : byte;
begin
 if Acount > 2 then writeAccu;
 scnt := Acount shl 3;
 Accu := accu or (w shl scnt);
 inc(Acount,2);
 if Acount = 4 then writeAccu;
end;

procedure writeDword(dw : dword);
begin
 writeAccu;
 accu := dw;
 Acount := 4;
 writeAccu;
end;

procedure writeSmallInt(w : smallInt);
begin
 writeword(word(w));
end;

procedure writeLongInt(w : longInt);
begin
 writedword(dword(w));
end;

procedure writesingle(ss : single);
type PDW = ^dword;
var dw : dword;
begin
 dw := pdw(@ss)^;
 writedword(dw);
end;

procedure writedouble(dd : double);
type Ta = array[0..1] of dword;
     Pa = ^Ta;
var dw : dword;
    a : Pa;
begin
 a := Pa(@dd);
 dw := a^[0];
 writedword(dw);
 dw := a^[1];
 writedword(dw);
end;

end.
